/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Activity;
import org.openapitools.client.model.Contact;
import org.openapitools.client.model.Location;
import org.openapitools.client.model.PlaceLinks;
import org.threeten.bp.LocalDate;

/**
 * PlaceRevision
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-12-19T15:07:54.107442+01:00[Europe/Rome]")
public class PlaceRevision {
  public static final String SERIALIZED_NAME_CREATED = "created";
  @SerializedName(SERIALIZED_NAME_CREATED)
  private Activity created;

  public static final String SERIALIZED_NAME_REV = "rev";
  @SerializedName(SERIALIZED_NAME_REV)
  private Long rev;

  public static final String SERIALIZED_NAME_TIT = "tit";
  @SerializedName(SERIALIZED_NAME_TIT)
  private String tit;

  public static final String SERIALIZED_NAME_DSC = "dsc";
  @SerializedName(SERIALIZED_NAME_DSC)
  private String dsc;

  public static final String SERIALIZED_NAME_LOC = "loc";
  @SerializedName(SERIALIZED_NAME_LOC)
  private Location loc;

  public static final String SERIALIZED_NAME_CNT = "cnt";
  @SerializedName(SERIALIZED_NAME_CNT)
  private Contact cnt;

  public static final String SERIALIZED_NAME_HRS = "hrs";
  @SerializedName(SERIALIZED_NAME_HRS)
  private String hrs;

  public static final String SERIALIZED_NAME_FND = "fnd";
  @SerializedName(SERIALIZED_NAME_FND)
  private LocalDate fnd;

  public static final String SERIALIZED_NAME_LNK = "lnk";
  @SerializedName(SERIALIZED_NAME_LNK)
  private PlaceLinks lnk;

  public static final String SERIALIZED_NAME_TAG = "tag";
  @SerializedName(SERIALIZED_NAME_TAG)
  private List<String> tag = null;


  public PlaceRevision created(Activity created) {
    
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @ApiModelProperty(required = true, value = "")

  public Activity getCreated() {
    return created;
  }


  public void setCreated(Activity created) {
    this.created = created;
  }


  public PlaceRevision rev(Long rev) {
    
    this.rev = rev;
    return this;
  }

   /**
   * A revision number 
   * minimum: 0
   * @return rev
  **/
  @ApiModelProperty(example = "23", required = true, value = "A revision number ")

  public Long getRev() {
    return rev;
  }


  public void setRev(Long rev) {
    this.rev = rev;
  }


  public PlaceRevision tit(String tit) {
    
    this.tit = tit;
    return this;
  }

   /**
   * Get tit
   * @return tit
  **/
  @ApiModelProperty(example = "A non-empty title", required = true, value = "")

  public String getTit() {
    return tit;
  }


  public void setTit(String tit) {
    this.tit = tit;
  }


  public PlaceRevision dsc(String dsc) {
    
    this.dsc = dsc;
    return this;
  }

   /**
   * Get dsc
   * @return dsc
  **/
  @ApiModelProperty(example = "A non-empty description", required = true, value = "")

  public String getDsc() {
    return dsc;
  }


  public void setDsc(String dsc) {
    this.dsc = dsc;
  }


  public PlaceRevision loc(Location loc) {
    
    this.loc = loc;
    return this;
  }

   /**
   * Get loc
   * @return loc
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Location getLoc() {
    return loc;
  }


  public void setLoc(Location loc) {
    this.loc = loc;
  }


  public PlaceRevision cnt(Contact cnt) {
    
    this.cnt = cnt;
    return this;
  }

   /**
   * Get cnt
   * @return cnt
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Contact getCnt() {
    return cnt;
  }


  public void setCnt(Contact cnt) {
    this.cnt = cnt;
  }


  public PlaceRevision hrs(String hrs) {
    
    this.hrs = hrs;
    return this;
  }

   /**
   * The opening hours in OpenStreetMap format.  Specification: https://wiki.openstreetmap.org/wiki/Key:opening_hours  Reference implementations: https://github.com/opening-hours/  Generator tool: https://projets.pavie.info/yohours/  The service trims leading/trailing whitespaces and stores values as is. Values are currently not validated against the OSM format syntax! 
   * @return hrs
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "24/7", value = "The opening hours in OpenStreetMap format.  Specification: https://wiki.openstreetmap.org/wiki/Key:opening_hours  Reference implementations: https://github.com/opening-hours/  Generator tool: https://projets.pavie.info/yohours/  The service trims leading/trailing whitespaces and stores values as is. Values are currently not validated against the OSM format syntax! ")

  public String getHrs() {
    return hrs;
  }


  public void setHrs(String hrs) {
    this.hrs = hrs;
  }


  public PlaceRevision fnd(LocalDate fnd) {
    
    this.fnd = fnd;
    return this;
  }

   /**
   * The date on which an organization, initiative, or company has been founded or established. 
   * @return fnd
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Wed Oct 24 01:00:00 CET 1945", value = "The date on which an organization, initiative, or company has been founded or established. ")

  public LocalDate getFnd() {
    return fnd;
  }


  public void setFnd(LocalDate fnd) {
    this.fnd = fnd;
  }


  public PlaceRevision lnk(PlaceLinks lnk) {
    
    this.lnk = lnk;
    return this;
  }

   /**
   * Get lnk
   * @return lnk
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public PlaceLinks getLnk() {
    return lnk;
  }


  public void setLnk(PlaceLinks lnk) {
    this.lnk = lnk;
  }


  public PlaceRevision tag(List<String> tag) {
    
    this.tag = tag;
    return this;
  }

  public PlaceRevision addTagItem(String tagItem) {
    if (this.tag == null) {
      this.tag = new ArrayList<String>();
    }
    this.tag.add(tagItem);
    return this;
  }

   /**
   * Get tag
   * @return tag
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "[\"organic\",\"non-profit\"]", value = "")

  public List<String> getTag() {
    return tag;
  }


  public void setTag(List<String> tag) {
    this.tag = tag;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PlaceRevision placeRevision = (PlaceRevision) o;
    return Objects.equals(this.created, placeRevision.created) &&
        Objects.equals(this.rev, placeRevision.rev) &&
        Objects.equals(this.tit, placeRevision.tit) &&
        Objects.equals(this.dsc, placeRevision.dsc) &&
        Objects.equals(this.loc, placeRevision.loc) &&
        Objects.equals(this.cnt, placeRevision.cnt) &&
        Objects.equals(this.hrs, placeRevision.hrs) &&
        Objects.equals(this.fnd, placeRevision.fnd) &&
        Objects.equals(this.lnk, placeRevision.lnk) &&
        Objects.equals(this.tag, placeRevision.tag);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, rev, tit, dsc, loc, cnt, hrs, fnd, lnk, tag);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PlaceRevision {\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    rev: ").append(toIndentedString(rev)).append("\n");
    sb.append("    tit: ").append(toIndentedString(tit)).append("\n");
    sb.append("    dsc: ").append(toIndentedString(dsc)).append("\n");
    sb.append("    loc: ").append(toIndentedString(loc)).append("\n");
    sb.append("    cnt: ").append(toIndentedString(cnt)).append("\n");
    sb.append("    hrs: ").append(toIndentedString(hrs)).append("\n");
    sb.append("    fnd: ").append(toIndentedString(fnd)).append("\n");
    sb.append("    lnk: ").append(toIndentedString(lnk)).append("\n");
    sb.append("    tag: ").append(toIndentedString(tag)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

